
TYPO3.Flow - Bug # 42269

Status: Closed Priority: Should have
Author: Christian Jul Jensen Category: - Testing -
Created: 2012-10-22 Assigned To: Christian Jul Jensen
Updated: 2012-12-10 Due date:
PHP Version:
Has patch: No
Complexity:
Affected Flow version: Git 1.2 (master)
Subject: Unittests fail with PHPunit 3.7(.8)
Description

Output:

There was 1 failure:

1)
TYPO3\Flow\Tests\Unit\Persistence\Generic\DataMapperTest::mapToObjectReconstitutesExpectedObjectAndRegistersItWithIdentityma
mapToObjects
Expectation failed for method name is equal to <string:registerObject> when invoked 1 time(s)
Parameter 0 for invocation TYPO3\Flow\Persistence\Generic\Session::registerObject(Entity519192b8dbb06b57f5a377fec3fc274e
Object (...), '1234') does not match expected value.
Failed asserting that two objects are equal.
--- Expected
++ Actual
@ @
 Entity519192b8dbb06b57f5a377fec3fc274e Object (
-    '__phpunit_id' => 'Entity519192b8dbb06b57f5a377f...274e#0'
    '__phpunit_id' => null
 )

/opt/local/apache2/htdocs/TYPO3-Flow/Packages/Framework/TYPO3.Flow/Classes/TYPO3/Flow/Persistence/Generic/DataMapper.
hp:107
/opt/local/apache2/htdocs/TYPO3-Flow/Packages/Framework/TYPO3.Flow/Tests/Unit/Persistence/Generic/DataMapperTest.php:84
/opt/local/apache2/htdocs/TYPO3-Flow/Packages/Framework/TYPO3.Flow/Tests/BaseTestCase.php:50

Related issues:
related to TYPO3.Flow - Bug # 42114: PHPUnit functional tests cannot be run w... Resolved 2012-10-18

History
#1 - 2012-10-23 15:41 - Christian Jul Jensen
- Assigned To set to Christian Jul Jensen

The issue here is that PHPUnit-Mock-Objects in has added an internal identifier '__phpunit_id' to mock objects, this property is not set correctly when
reconstituting the objects in DataMapper::mapToObjetcs. The expect calls in
mapToObjectReconstitutesExpectedObjectAndRegistersItWithIdentitymapToObjects thus fails because the objects are not identical.

There are bugs reported for PHPUnit Mock Objects which might solve this, namely 
https://github.com/sebastianbergmann/phpunit-mock-objects/issues/100, but most likely the test will have to be adjusted to test whether the
reconstitution is correct, and not whether the objects are identical.
For now, we have decided to just skip the test for 3.7

#2 - 2012-10-23 15:50 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/15905

#3 - 2012-10-25 10:33 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/15905

#4 - 2012-12-10 13:13 - Karsten Dambekalns
- Status changed from Under Review to Closed

Change has been abandoned.
